Ruby - Bug #6115

A block after the do-block without parenthesis
03/05/2012 10:59 PM - nobu (Nobuyoshi Nakada)
Assignee:
34643) [x86_64-darwin11.3.0]

Description

=begin

= ((<pull request 102 by pasberth: A block after the do-block without parenthesis|URL:https:/github.com/ruby/ruby/pull/102>))
((<patch|URL:https://qgithub.com/pasberth/ruby/commit/2d6624238aae89110141a8e223f244bf92eb27a9>))

| think seemingly this source code is no problem:
$ cat unexpected.rb

langs = ["Ruby"]

langs.each_with_object [] do |lang, the_langs|
the_langs << "The #{lang}"

end.each do [the_lang|

puts the_lang

end

But syntax error:

$ ruby unexpected.rb

unexpected.rb:4: syntax error, unexpected keyword_do
end.each do |the_lang|

A

unexpected.rb:5: syntax error, unexpected tIDENTIFIER, expecting keyword_do or '{ or '(’
| want to this code behaves like:

$ cat expected.rb

langs = ["Ruby"]

(langs.each_with_object [] do |lang, the_langs|
the_langs << "The #{lang}"

end).each do [the_lang|

puts the_lang

end

$ ruby expected.rb
The Ruby

| changed the block_call in the parse.y to a primary-expression.

$ ./ruby -1./lib -1. unexpected.rb
The Ruby

00000000o0boobonoonoo
00 unexpected.ro 0000000000000000000000DO00DD

00000000000000
00000000o00o0no0no0Do0honDoo

=end
https://github.com/ruby/ruby/pull/102%3E
https://github.com/pasberth/ruby/commit/2d6624238aae89110141a8e223f244bf92eb27a9%3E

Associated revisions

Revision c46bdadb84bec5fd4484e4375e2935d740984618 - 03/05/2012 04:34 PM - nobu (Nobuyoshi Nakada)

e parse.y (block_call): rules for block_call after block_call.
based on a patch by pasberth https://github.com/ri r /102
[ruby-dev:45308][Bug #6115]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@34913 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision c46bdadb - 03/05/2012 04:34 PM - nobu (Nobuyoshi Nakada)

e parse.y (block_call): rules for block_call after block_call.
based on a patch by pasberth https://github.com/ruby/ruby/pull/102
[ruby-dev:45308][Bug #6115]

git-svn-id: svn+ssh:/ci.ruby-lang.org/ruby/trunk@34913 b2dd03c8-39d4-408f-98ff-823fe69b080e

History

#1 - 03/06/2012 01:34 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed
- % Done changed from 0 to 100

This issue was solved with changeset r34913.
Nobuyoshi, thank you for reporting this issue.
Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

e parse.y (block_call): rules for block_call after block_call.
based on a patch by pasberth https://github.com/ruby/ruby/pull/102
[ruby-dev:45308][Bug #6115]
